about summary refs log tree commit diff stats
path: root/home-manager/config/yambar/scripts
diff options
context:
space:
mode:
Diffstat (limited to 'home-manager/config/yambar/scripts')
-rwxr-xr-xhome-manager/config/yambar/scripts/amixer-monitor24
-rwxr-xr-xhome-manager/config/yambar/scripts/cpu126
-rwxr-xr-xhome-manager/config/yambar/scripts/dfspace23
-rwxr-xr-xhome-manager/config/yambar/scripts/grades-average12
-rwxr-xr-xhome-manager/config/yambar/scripts/meminfo37
-rwxr-xr-xhome-manager/config/yambar/scripts/nmclitest23
-rwxr-xr-xhome-manager/config/yambar/scripts/pingtest28
-rwxr-xr-xhome-manager/config/yambar/scripts/yambar-tray27
-rwxr-xr-xhome-manager/config/yambar/scripts/yambar-tray-width28
9 files changed, 328 insertions, 0 deletions
diff --git a/home-manager/config/yambar/scripts/amixer-monitor b/home-manager/config/yambar/scripts/amixer-monitor
new file mode 100755
index 00000000..9e75acfa
--- /dev/null
+++ b/home-manager/config/yambar/scripts/amixer-monitor
@@ -0,0 +1,24 @@
+#!/bin/sh
+# An improved amixer script that actually detects volume beyond 100%
+
+
+SLEEPTIME=1
+
+
+while true; do
+
+    volume=$(pactl get-sink-volume 0 | awk 'BEGIN { FS="/"} {print $2 }' | tr -d "%" | tr -d ' ')
+ 
+    if [ "$volume" -eq 0 ]; then
+        echo "muted|bool|true"
+
+    else
+        # Read sink volume in percentages
+        echo "volume|string|$volume"
+        echo "muted|bool|false"
+    fi
+
+    echo ""
+    sleep "$SLEEPTIME"
+
+done
diff --git a/home-manager/config/yambar/scripts/cpu b/home-manager/config/yambar/scripts/cpu
new file mode 100755
index 00000000..bae820d0
--- /dev/null
+++ b/home-manager/config/yambar/scripts/cpu
@@ -0,0 +1,126 @@
+#!/bin/bash
+# I didn't write this script; this is almost directly copied from the dnkl/yambar github.
+
+
+# cpu.sh - measures CPU usage at a configurable sample interval
+#
+# Usage: cpu.sh INTERVAL_IN_SECONDS
+#
+# This script will emit the following tags on stdout (N is the number
+# of logical CPUs):
+#
+#  Name   Type
+#  --------------------
+#  cpu    range 0-100
+#  cpu0   range 0-100
+#  cpu1   range 0-100
+#  ...
+#  cpuN-1 range 0-100
+#
+# I.e. ‘cpu’ is the average (or aggregated) CPU usage, while cpuX is a
+# specific CPU’s usage.
+#
+# Example configuration (update every second):
+#
+#  - script:
+#      path: /path/to/cpu.sh
+#      args: [1]
+#      content: {string: {text: "{cpu}%"}}
+#
+
+interval=2
+
+case ${interval} in
+    ''|*[!0-9]*)
+        echo "interval must be an integer"
+        exit 1
+        ;;
+    *)
+        ;;
+esac
+
+# Get number of CPUs, by reading /proc/stat
+# The output looks like:
+#
+#  cpu  A B C D ...
+#  cpu0 A B C D ...
+#  cpu1 A B C D ...
+#  cpuN A B C D ...
+#
+# The first line is a summary line, accounting *all* CPUs
+IFS=$'\n' readarray -t all_cpu_stats < <(grep -e "^cpu" /proc/stat)
+cpu_count=$((${#all_cpu_stats[@]} - 1))
+
+# Arrays of ‘previous’ idle and total stats, needed to calculate the
+# difference between each sample.
+prev_idle=()
+prev_total=()
+for i in $(seq ${cpu_count}); do
+    prev_idle+=(0)
+    prev_total+=(0)
+done
+
+prev_average_idle=0
+prev_average_total=0
+
+while true; do
+    IFS=$'\n' readarray -t all_cpu_stats < <(grep -e "^cpu" /proc/stat)
+
+    usage=()           # CPU usage in percent, 0 <= x <= 100
+
+    average_idle=0  # All CPUs idle time since boot
+    average_total=0 # All CPUs total time since boot
+
+    for i in $(seq 0 $((cpu_count - 1))); do
+        # Split this CPUs stats into an array
+        stats=($(echo "${all_cpu_stats[$((i + 1))]}"))
+
+        # man procfs(5)
+        user=${stats[1]}
+        nice=${stats[2]}
+        system=${stats[3]}
+        idle=${stats[4]}
+        iowait=${stats[5]}
+        irq=${stats[6]}
+        softirq=${stats[7]}
+        steal=${stats[8]}
+        guest=${stats[9]}
+        guestnice=${stats[10]}
+
+        # Guest time already accounted for in user
+        user=$((user - guest))
+        nice=$((nice - guestnice))
+
+        idle=$((idle + iowait))
+
+        total=$((user + nice + system + irq + softirq + idle + steal + guest + guestnice))
+
+        average_idle=$((average_idle + idle))
+        average_total=$((average_total + total))
+
+        # Diff since last sample
+        diff_idle=$((idle - prev_idle[i]))
+        diff_total=$((total - prev_total[i]))
+
+        usage[i]=$((100 * (diff_total - diff_idle) / diff_total))
+
+        prev_idle[i]=${idle}
+        prev_total[i]=${total}
+    done
+
+    diff_average_idle=$((average_idle - prev_average_idle))
+    diff_average_total=$((average_total - prev_average_total))
+
+    average_usage=$((100 * (diff_average_total - diff_average_idle) / diff_average_total))
+
+    prev_average_idle=${average_idle}
+    prev_average_total=${average_total}
+
+    echo "cpu|range:0-100|${average_usage}"
+    for i in $(seq 0 $((cpu_count - 1))); do
+        echo "cpu${i}|range:0-100|${usage[i]}"
+    done
+
+    echo ""
+    sleep "${interval}"
+done
diff --git a/home-manager/config/yambar/scripts/dfspace b/home-manager/config/yambar/scripts/dfspace
new file mode 100755
index 00000000..0b262481
--- /dev/null
+++ b/home-manager/config/yambar/scripts/dfspace
@@ -0,0 +1,23 @@
+#!/bin/sh
+
+# Sleep seconds
+timer="60"
+
+# Main loop
+while true; do
+
+    # vars
+    used_space=$(btrfs filesystem usage / 2> /dev/null | awk '{if ( /Used:/ ) { print $2 } } ' | head -n1)
+    all_space=$(btrfs filesystem usage / 2> /dev/null | awk '{if ( /Device size:/ ) { print $3 } } ' | head -n1 | tr -d "GiB")
+    
+
+  # Check space available (4) and percentage used (5)
+  spaceperc=$(echo "$(echo "$used_space" | tr -d "GiB" )"  "$all_space"  | awk '{div=$1/$2;div *= 100; printf"%2d%%\n",div }')
+
+  echo "diskspace|string|$used_space"
+  echo "diskperc|string|$spaceperc"
+  echo ""
+  sleep $timer
+
+done
+
diff --git a/home-manager/config/yambar/scripts/grades-average b/home-manager/config/yambar/scripts/grades-average
new file mode 100755
index 00000000..a04b958c
--- /dev/null
+++ b/home-manager/config/yambar/scripts/grades-average
@@ -0,0 +1,12 @@
+#!/bin/sh
+# shellcheck disable=SC2086
+# shellcheck source=/dev/null
+. ~/.local/lib/shell/lib
+
+grade=$(grades list average | awk '{print $2}');
+
+echo "grade|string|$grade";
+echo "";
+
+
+if [ -d /tmp/LIB_FILE_TEMP_DIR/ ];then rm -r /tmp/LIB_FILE_TEMP_DIR/; fi
diff --git a/home-manager/config/yambar/scripts/meminfo b/home-manager/config/yambar/scripts/meminfo
new file mode 100755
index 00000000..0156e94c
--- /dev/null
+++ b/home-manager/config/yambar/scripts/meminfo
@@ -0,0 +1,37 @@
+#!/bin/sh
+# Checks memory usage
+
+# Number of seconds to retest
+timer=5
+
+# Main loop
+while true; do
+
+    mem_total=$(LANG=C free -b|awk '/^Mem:/{print $2}')
+    mem_used=$(LANG=C free -b|awk '/^Mem:/{print $3}')
+    swap_total=$(LANG=C free -b|awk '/^Swap:/{print $2}')
+    swap_used=$(LANG=C free -b|awk '/^Swap:/{print $3}')
+
+
+    memperc=$(echo "$mem_used" "$mem_total" |  awk '{ div = 100 * ($1 / $2)} { printf "%.0f ", div }' | tr -d ' ' )
+    swapperc=$(echo "$swap_used" "$swap_total" |  awk '{
+    if ( $1 == 0 || $2 == 0 ) {
+        print "%"
+    } else {
+    div = 100 * ($1 / $2); 
+    printf "%.0f ", div
+}
+}' | tr -d ' ' )
+
+
+echo "memperc|string|$memperc"
+if [ "$swapperc" = "%" ];then
+    echo "swapstate|bool|false"
+else
+    echo "swapperc|string|$swapperc"
+    echo "swapstate|bool|true"
+fi
+echo ""
+sleep "$timer"
+
+done
diff --git a/home-manager/config/yambar/scripts/nmclitest b/home-manager/config/yambar/scripts/nmclitest
new file mode 100755
index 00000000..3e8bc73a
--- /dev/null
+++ b/home-manager/config/yambar/scripts/nmclitest
@@ -0,0 +1,23 @@
+#!/bin/sh
+# Test for connectivity with nmcli
+
+Timer=${1:-120}   # Number of seconds to retest
+Timer2=${2:-10}   # Number of seconds to retest if connection fails
+
+# Main loop
+while true; do
+
+  CONN=$(nmcli networking connectivity)
+
+  if [[ "$CONN" == "full" ]]; then
+      echo "internet|string|Connected"
+      echo ""
+      sleep $Timer
+  else
+      echo "internet|string|Disconnected"
+      echo ""
+      sleep $Timer2
+  fi
+
+done
+
diff --git a/home-manager/config/yambar/scripts/pingtest b/home-manager/config/yambar/scripts/pingtest
new file mode 100755
index 00000000..2b5f9998
--- /dev/null
+++ b/home-manager/config/yambar/scripts/pingtest
@@ -0,0 +1,28 @@
+#!/bin/sh
+# Test for connectivity with ping
+
+Timer=${1:-120}   # Number of seconds to retest
+Timer2=${2:-10}   # Number of seconds to retest if connection fails
+IP=${3:-'8.8.8.8'}   # IP address to test, defaults to Google
+PCount=${4:-3}   # Number of pings to send
+
+# Main loop
+while true; do
+
+  # Pings the IP address for five times
+  PINGSTR=$(ping $IP -c $PCount -q)
+  # Use text formatting to get min/max ms delays
+  MED=$(echo $PINGSTR | sed 's/min\/avg\/max\/mdev = /\n/g' | tail -n 1 | sed 's/\//\t/g' | cut -f2)
+
+  if [[ "$MED" == "" ]]; then
+      echo "med|string|No connection"
+      echo ""
+      sleep $Timer2
+  else
+      echo "med|string|$MED ms"
+      echo ""
+      sleep $Timer
+  fi
+
+done
+
diff --git a/home-manager/config/yambar/scripts/yambar-tray b/home-manager/config/yambar/scripts/yambar-tray
new file mode 100755
index 00000000..1704c6dd
--- /dev/null
+++ b/home-manager/config/yambar/scripts/yambar-tray
@@ -0,0 +1,27 @@
+#!/bin/sh
+
+
+pkill stalonetray
+pkill trayer
+
+# launch a tray.
+echo
+
+sleep 0.1 # make sure yambar starts first so we can draw on tpo of it
+
+# trayer-srg fork!
+trayer \
+    --edge top \
+    --tint 0x24242400 \
+    --align right \
+    --height 20 \
+    --expand false  \
+    --transparent true \
+    --alpha 0 \
+    --width 20  \
+    --monitor primary \
+    --widthtype request
+    # &>/dev/null
+
+
+
diff --git a/home-manager/config/yambar/scripts/yambar-tray-width b/home-manager/config/yambar/scripts/yambar-tray-width
new file mode 100755
index 00000000..00544e70
--- /dev/null
+++ b/home-manager/config/yambar/scripts/yambar-tray-width
@@ -0,0 +1,28 @@
+#!/bin/sh
+# shellcheck disable=SC2086
+# shellcheck source=/dev/null
+. ~/.local/lib/shell/lib
+
+
+CHARWIDTH=8 # i guess?
+
+tray_width_px() {
+    xwininfo -name panel | # trayer names its window "panel"
+        grep -i width: |
+        awk '{print $2}'
+}
+
+px_to_spaces() {
+    spaces="$((1 + ${1:-0} / $CHARWIDTH))"
+    printf "% *s\n" $spaces
+}
+
+sleep 0.2 # be sure trayer is already up
+
+output="$(px_to_spaces `tray_width_px`)"
+echo  "padding|string|$output"
+echo ""
+
+
+
+if [ -d /tmp/LIB_FILE_TEMP_DIR/ ];then rm -r /tmp/LIB_FILE_TEMP_DIR/; fi